set(_QEVERCLOUD_QT_COMPONENTS "")
list(APPEND _QEVERCLOUD_QT_COMPONENTS "Core")
list(APPEND _QEVERCLOUD_QT_COMPONENTS "Network")

if(BUILD_TRANSLATIONS)
  list(APPEND _QEVERCLOUD_QT_COMPONENTS "LinguistTools")
endif()

if(_QEVERCLOUD_USE_QT6)
  if(NOT DEFINED OpenGL_GL_PREFERENCE AND NOT CACHE{OpenGL_GL_PREFERENCE} AND NOT ENV{OpenGL_GL_PREFERENCE})
    set(OpenGL_GL_PREFERENCE GLVND)
  endif()

  set(_QEVERCLOUD_MIN_QT6_VERSION 6.0.0)

  if(BUILD_WITH_OAUTH_SUPPORT)
    if(QEVERCLOUD_USE_SYSTEM_BROWSER)
      list(APPEND _QEVERCLOUD_QT_COMPONENTS "Gui" "Widgets")
    else()
      list(APPEND _QEVERCLOUD_QT_COMPONENTS "WebEngineCore" "WebEngineWidgets")
      set(_QEVERCLOUD_MIN_QT6_VERSION 6.4.0)
    endif()
  endif()

  find_package(Qt6 ${_QEVERCLOUD_MIN_QT6_VERSION} COMPONENTS ${_QEVERCLOUD_QT_COMPONENTS} ${QEVERCLOUD_FIND_QT_ARGS})
else()
  if(BUILD_WITH_OAUTH_SUPPORT)
    if(QEVERCLOUD_USE_SYSTEM_BROWSER)
      list(APPEND _QEVERCLOUD_QT_COMPONENTS "Widgets")
    else()
      list(APPEND _QEVERCLOUD_QT_COMPONENTS "WebEngineCore" "WebEngineWidgets")
    endif()
  endif()

  find_package(Qt5 5.12.0 COMPONENTS ${_QEVERCLOUD_QT_COMPONENTS} ${QEVERCLOUD_FIND_QT_ARGS})
endif()
