/**
 * Original work: Copyright (c) 2014 Sergey Skoblikov
 * Modified work: Copyright (c) 2015-2025 Dmitry Ivanov
 *
 * This file is a part of QEverCloud project and is distributed under the terms
 * of MIT license:
 * https://opensource.org/licenses/MIT
 *
 * This file was generated from Evernote Thrift API
 */

#include "NotebookShareTemplateImpl.h"

#include "../../Impl.h"

#include <QTextStream>

namespace qevercloud {

void NotebookShareTemplate::Impl::print(QTextStream & strm) const
{
    strm << "NotebookShareTemplate: {\n";

    if (m_notebookGuid) {
        strm << "    notebookGuid = "
            << *m_notebookGuid << "\n";
    }
    else {
        strm << "    notebookGuid is not set\n";
    }

    if (m_recipientThreadId) {
        strm << "    recipientThreadId = "
            << *m_recipientThreadId << "\n";
    }
    else {
        strm << "    recipientThreadId is not set\n";
    }

    if (m_recipientContacts) {
        strm << "    recipientContacts = "
            << "QList<Contact> {";
        for(const auto & v: *m_recipientContacts) {
            strm << "        " << v << "\n";
        }
        strm << "    }\n";
    }
    else {
        strm << "    recipientContacts is not set\n";
    }

    if (m_privilege) {
        strm << "    privilege = "
            << *m_privilege << "\n";
    }
    else {
        strm << "    privilege is not set\n";
    }

    strm << "}\n";
}

} // namespace qevercloud
